/*
 * Removal of this header is illegal.
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2002 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/sauge/code/progress/ezine35/RCS/Decrypt.p,v 1.1 2003/07/29 06:46:48 sauge Exp sauge $" NO-UNDO. 

/* Call out to gpg to do a decrypt of data */

DEF INPUT  PARAMETER cEncryptData AS CHARACTER NO-UNDO.
DEF INPUT  PARAMETER cKeyName     AS CHARACTER NO-UNDO.
DEF INPUT  PARAMETER cPassPhrase   AS CHARACTER NO-UNDO.
DEF OUTPUT PARAMETER cPlainData   AS CHARACTER NO-UNDO.

DEF VAR cEncryptFileName AS CHARACTER NO-UNDO.
DEF VAR cPlainFileName AS CHARACTER NO-UNDO.

/* Our defaults - might want to make them else wehere */

ASSIGN cEncryptFileName = "/tmp/testdata.asc".
ASSIGN cPlainFileName = "/tmp/plain.txt".

/* Take varible containing encrypted text and place it into a file. */

OUTPUT TO VALUE(cEncryptFileName). 
PUT UNFORMATTED cEncryptData.
OUTPUT CLOSE.


/* Convert that file into a plaintext file */
/* Note we do some funky stuff to get the passphrase into the string via the --passphrase-fd */

input-output thru  gpg -a --batch --no-tty --passphrase-fd 0 -r VALUE(cKeyName) -o VALUE(cPlainFileName) --yes -d VALUE(cEncryptFileName) .
put UNFORMATTED cPassPhrase.
input-output close.

/* Load the output varible with the file's contents */

RUN ReadTextFile.p (INPUT cPlainFileName, OUTPUT cPlainData).

/* Clean house */

OS-DELETE VALUE(cPlainFileName).
OS-DELETE VALUE(cEncryptFileName).

