
/* Call out to gpg to do a decrypt of data */

DEF INPUT  PARAMETER cEncryptData AS CHARACTER NO-UNDO.
DEF INPUT  PARAMETER cKeyName     AS CHARACTER NO-UNDO.
DEF INPUT PARAMETER cPassPhrase   AS CHARACTER NO-UNDO.
DEF OUTPUT PARAMETER cPlainData   AS CHARACTER NO-UNDO.

DEF VAR cEncryptFileName AS CHARACTER NO-UNDO.
DEF VAR cPlainFileName AS CHARACTER NO-UNDO.

/* Our defaults - might want to make them else wehere */

ASSIGN cEncryptFileName = "/tmp/testdata.asc".
ASSIGN cPlainFileName = "/tmp/plain.txt".

/* Take varible containing encrypted text and place it into a file. */

OUTPUT TO VALUE(cEncryptFileName). 
PUT cPassPhrase.
OUTPUT CLOSE.


/* Convert that file into a plaintext file */

input-output thru  gpg -a --batch --no-tty --passphrase-fd 0 -r VALUE(cKeyName) -o VALUE(cPlainFileName) --yes -d VALUE(cEncryptFileName) .
put cPassPhrase.
input-output close.

/* Load the output varible with the file's contents */

RUN ReadTextFile.p (INPUT cPlainFileName, OUTPUT cPlainData).

/* Clean house */

OS-DELETE VALUE(cPlainFileName).
OS-DELETE VALUE(cEncryptFileName).

